import java.nio.file.Files;
import java.nio.file.Paths;

import org.odmg.Database;
import org.odmg.OQLQuery;
import org.odmg.Transaction;

import rasj.RasGMArray;
import rasj.RasImplementation;
import rasj.RasMInterval;

public class CreateCollection{

	public static void main(String [] args){

		RasImplementation rasImpl = new RasImplementation("http://localhost:7001");
		Transaction transaction = null;

		try{

			rasImpl.setUserIdentification("rasadmin", "rasadmin");
			Database rasDb = rasImpl.newDatabase();

			rasDb.open("RASBASE", Database.OPEN_READ_WRITE);

			transaction = rasImpl.newTransaction();
			transaction.begin();

	    OQLQuery myQu = rasImpl.newOQLQuery();

	    myQu.create("create collection my_collection GreySet");
			myQu.execute();

			RasGMArray mdd = createMDDFromFile("/tmp/polygon.tiff");
			mdd.setObjectTypeName("GreyImage");
 
			myQu.create("insert into my_collection values inv_tiff( $1 )");
			myQu.bind(mdd);
			myQu.execute();

		}
		catch(Exception ex){

			ex.printStackTrace();

		}
		finally{
			if(transaction != null){
				transaction.commit();
			}
		}

	}

	public static RasGMArray createMDDFromFile(String fileName) throws Exception{
		
		RasGMArray mdd = new RasGMArray(new RasMInterval("[1:422,1:229]"), 1);
		byte [] array = Files.readAllBytes(Paths.get(fileName));
		mdd.setArray(array);
		
		return mdd;

	}

}